'use strict';

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

(function () {
  var root = (typeof window === 'undefined' ? 'undefined' : _typeof(window)) === 'object' && window.window === window && window || (typeof global === 'undefined' ? 'undefined' : _typeof(global)) === 'object' && global.global === global && global || this || {};
  var si = root.si = {};
  if ((typeof module === 'undefined' ? 'undefined' : _typeof(module)) === 'object' && _typeof(module.exports) === 'object') {
    module.exports = root.si;
  }

  si.inFunction = function (fName, fFunc) {
    if (typeof fName !== 'string' || typeof fFunc !== 'function') {
      console.error('invalid function!');
      return false;
    }
    if (!si.$$customizeFunctions) {
      si.$$customizeFunctions = {};
    }
    if (si.$$customizeFunctions[fName]) {
      console.error('Function ' + fName + ' is already exist!');
      return false;
    }
    si.$$customizeFunctions[fName] = fFunc;
  };

  si.unFunction = function (fName) {
    try {
      si.$$customizeFunctions[fName] = null;
      delete si.$$customizeFunctions[fName];
      return true;
    } catch (e) {
      return false;
    }
  };

  si.getFunction = function (fName) {
    return si.$$customizeFunctions[fName] || String.prototype[fName];
  };

  si.handleFormat = function (strInput, fName) {
    var arr = fName.split(/[(),]/);
    var _name = arr[0];
    arr.shift();
    arr.pop();
    var func = si.getFunction(_name);
    if (func) {
      return func.apply(strInput, arr);
    } else {
      console.warn('Function ' + _name + ' cannot be found, original value ' + strInput + ' will be returned.');
      return strInput;
    }
  };

  si.solve = function (str) {
    for (var _len = arguments.length, args = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      args[_key - 1] = arguments[_key];
    }

    if (typeof str === 'undefined' || str === '') {
      console.error('Parameter 0 should have truly content!');
      return false;
    }
    var result = str;
    var len = args.length;

    var reg = /\${[^${}]*}/g;

    if (len === 1 && _typeof(args[0]) === 'object') {
      result = str.replace(reg, function (matcher) {
        var m = matcher.slice(2, -1);
        var tmp = m.replace(/\s/g, '').split('|'),
            key = tmp[0],
            fun = tmp[1];
        var keyArray = key.split('.');
        var val = args[0];
        for (var k in keyArray) {
          val = val[keyArray[k]];
        }
        if (val) {
          if (fun) {
            return si.handleFormat(val, fun);
          }
          return val;
        }
        return "";
      });
    } else {
      var i = 0;
      result = str.replace(reg, function (matcher) {
        var m = matcher.slice(2, -1);
        var tmp = m.replace(/\s/g, '').split('|'),
            key = tmp[0],
            fun = tmp[1],
            ag = args[i++];
        if (ag) {
          var val = ag;
          if ((typeof val === 'undefined' ? 'undefined' : _typeof(val)) === 'object') {
            var keyArray = key.split('.');
            for (var k in keyArray) {
              val = val[keyArray[k]];
            }
          }
          if (fun) {
            return si.handleFormat(val, fun);
          }
          return val;
        }
        return "";
      });
    }
    return result;
  };
})();
